unit main;

{ TODO :     GlobalDiz  }
interface

uses
  Windows, SysUtils, Forms, Messages, Functions,
  Classes, Inifiles, Controls, StdCtrls, Dialogs, Vcl.ExtCtrls;

{$SetPEFlags IMAGE_FILE_RELOCS_STRIPPED}
{$WEAKLINKRTTI ON}

type
  TfmMain = class(TForm)
    OpenFileD: TOpenDialog;
    Panel1: TPanel;
    SettingsBtn: TButton;
    Button1: TButton;
    Button2: TButton;
    groups: TComboBox;
    RBUser: TRadioButton;
    RBGroup: TRadioButton;
    Edit1: TEdit;
    Panel2: TPanel;
    Label1: TMemo;
    procedure Button2Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure RBUserClick(Sender: TObject);
    procedure RBGroupClick(Sender: TObject);
    procedure SettingsBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
  end;

var
  fmMain: TfmMain;
  // s:string;

implementation

uses Option, helpform;

{$R *.dfm}
{$R ICO.res}

procedure TfmMain.Button2Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfmMain.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Application.Terminate;
  if Key = VK_RETURN then
  begin
    Button1.Click;
  end;
end;

{
  add_diz.exe /GROUP=GROUPNAME|/USER=USERCOLUMNFILE [/DIZ=DESCRIPTION] FILENAME
}
procedure TfmMain.Button1Click(Sender: TObject);
begin
  if Usergroup then
  begin
    if groups.Text <> '' then
      saveuserdiz(settings.GlobaldizFolder + groups.Text + '.diz',
        iset.FILENAME, Edit1.Text, settings, iset);
  end
  else
    SaveDiz(groups.Text, iset.FILENAME, Edit1.Text, settings, iset);
  Application.Terminate;
end;

procedure TfmMain.RBUserClick(Sender: TObject);
begin
  Usergroup := True;
  GetUserColumns(groups, settings);
  groups.DroppedDown := True;
end;

procedure TfmMain.RBGroupClick(Sender: TObject);
begin
  Usergroup := False;
  GetGroups(groups, settings);
end;

procedure TfmMain.SettingsBtnClick(Sender: TObject);
begin
  fmOptions.Showmodal;
end;

procedure TfmMain.FormShow(Sender: TObject);
begin
  if iset.OPTIONS then
    fmOptions.Showmodal;
  if iset.HELP then
    fmHelp.Showmodal;
  Top := (Screen.Height div 2) - (Height div 2);
  Left := (Screen.Width div 2) - (Width div 2);
end;

procedure TfmMain.FormCreate(Sender: TObject);
var
  Count: Byte;
  ps: string;
begin
  // messagebox (application.Handle,pchar(cmdline),'',0);
  // messagebox (application.Handle,pchar(paramstr (1)+'|'+paramstr (2)+'|'+paramstr (3)+'|'+paramstr (4)),pchar(paramstr (2)),0);
  if ParamCount < 1 then
    Halt;

  Font.Assign(Screen.IconFont);
  Label1.Font.Name := Screen.IconFont.Name;
  RBGroup.Font.Name := Screen.IconFont.Name;
  RBUser.Font.Name := Screen.IconFont.Name;
  Constraints.MinHeight := Height;
  Constraints.MinWidth := Width;

  iset.AUTODETECTFILENAME := True;
  iset.LIST := False;
  for Count := 1 to ParamCount do
  begin
    ps := ParamStr(Count);
    if (LowerCase(ParamStr(Count)) = '/o') then
    begin
      iset.OPTIONS := True;
      Exit;
    end;
    if (ParamStr(Count) = '/?') then
    begin
      iset.HELP := True;
      Exit;
    end;
    if (LowerCase(ParamStr(Count)) = '/c') or
      (LowerCase(ParamStr(Count)) = '/clear') then
    begin
      iset.CLEAR := True;
      Continue;
    end;
    if (LowerCase(ParamStr(Count)) = '/g') or
      (LowerCase(ParamStr(Count)) = '/gui') then
    begin
      iset.GUI := True;
      Continue;
    end;
    if (Copy(LowerCase(ParamStr(Count)), 1, 5) = '/delete') or
      (LowerCase(ParamStr(Count)) = '/d') then
    begin
      iset.DELETE := True;
      Continue;
    end;
    if (Copy(LowerCase(ParamStr(Count)), 1, 6) = '/group') then
    begin
      iset.USER := False;
      iset.GROUP := Copy(ParamStr(Count), 8, length(ParamStr(Count)) - 7);
      Continue;
    end;
    if (Copy(LowerCase(ParamStr(Count)), 1, 5) = '/user') then
    begin
      iset.USER := True;
      iset.USERFILE := settings.GlobaldizFolder + Copy(ParamStr(Count), 7,
        length(ParamStr(Count)) - 6);
      if extractfileext(iset.USERFILE) = '' then
        iset.USERFILE := iset.USERFILE + '.diz';
      Continue;
    end;
    if (Copy(LowerCase(ParamStr(Count)), 1, 4) = '/diz') then
    begin
      iset.DIZ := Copy(ParamStr(Count), 6, length(ParamStr(Count)) - 5);
      if iset.DIZ = '?' then
        iset.DIZ := InputBox('Description request', 'Enter decription:', '');
      Continue;
    end;
    if (Copy(LowerCase(ParamStr(Count)), 1, 5) = '/list') then
    begin
      iset.FILENAME := Copy(ParamStr(Count), 7, length(ParamStr(Count)) - 6);
      iset.LIST := True;
      iset.AUTODETECTFILENAME := False;
      Continue;
    end;
    if (Copy(LowerCase(ParamStr(Count)), 1, 5) = '/file') then
    begin
      iset.FILENAME := Copy(ParamStr(Count), 7, length(ParamStr(Count)) - 6);
      iset.AUTODETECTFILENAME := False;
      iset.LIST := False;
      Continue;
    end;
    if (ParamStr(Count)[1] <> '/') and (ParamStr(Count)[1] <> '-') and
      (iset.AUTODETECTFILENAME) then
    begin
      iset.FILENAME := ParamStr(Count);
      Continue;
    end;
    // if parameter not implemented:
    iset.HELPONERROR := 'Plugin help: unknown command-line pearameter "' +
      ParamStr(Count) + '"';
    iset.HELP := True;
    Exit;
  end;
  if iset.CLEAR then
  begin
    ClearDiz(settings);
    Reread_need;
    Halt;
  end;
  if iset.GUI then
  begin
    if iset.FILENAME = '' then
    begin
      while iset.FILENAME = '' do {  }
      begin
        OpenFileD.Execute;
        if (OpenFileD.FILENAME = '') or (not fileexists(OpenFileD.FILENAME))
        then
          Halt
        else
          iset.FILENAME := OpenFileD.FILENAME;
      end;
    end;
    if IsTcListFile(iset.FILENAME) or (iset.LIST) then
      Label1.Lines.Text := 'Set description for list of files'
    else
      Label1.Lines.Text := 'Set description for ' + iset.FILENAME;
    Caption := iset.FILENAME;
    GetGroups(groups, settings);
    Exit;
  end;
  if iset.DELETE then
  begin
    if iset.USER then
    begin
      DelDiz(iset.USERFILE, iset.FILENAME, iset);
      Reread_need;
      Halt;
    end
    else
    begin
      DelDiz(settings.GlobalDizFileName, iset.FILENAME, iset);
      Reread_need;
      Halt;
    end;
    Exit;
  end;
  if iset.USER then
  begin
    saveuserdiz(iset.USERFILE, iset.FILENAME, iset.DIZ, settings, iset);
    Reread_need;
    Halt;
  end
  else
  begin
    SaveDiz(iset.GROUP, iset.FILENAME, iset.DIZ, settings, iset);
    Reread_need;
    Halt;
  end;

end;

procedure TfmMain.Button2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Application.Terminate;
end;

end.
